当前位置:首页 > 芯闻号 > 充电吧
[导读]题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5534 题面: Partial Tree Time Limit: 2000/1000 MS (Jav

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5534


题面:

Partial Tree Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
Total Submission(s): 763    Accepted Submission(s): 374


Problem Description In mathematics, and more specifically in graph theory, a tree is an undirected graph in which any two nodes are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.

You find a partial tree on the way home. This tree has n nodes but lacks of n−1 edges. You want to complete this tree by adding n−1 edges. There must be exactly one path between any two nodes after adding. As you know, there are nn−2 ways to complete this tree, and you want to make the completed tree as cool as possible. The coolness of a tree is the sum of coolness of its nodes. The coolness of a node is f(d), where f is a predefined function and d is the degree of this node. What's the maximum coolness of the completed tree?  
Input The first line contains an integer T indicating the total number of test cases.
Each test case starts with an integer n in one line,
then one line with n−1 integers f(1),f(2),…,f(n−1).

1≤T≤2015
2≤n≤2015
0≤f(i)≤10000
There are at most 10 test cases with n>100.  
Output For each test case, please output the maximum coolness of the completed tree in one line.  
Sample Input
2
3
2 1
4
5 1 4

 

Sample Output
5
19

 

Source 2015ACM/ICPC亚洲区长春站-重现赛(感谢东北师大)  

题意:

    给定一颗无向树的节点数和各个度对应的权值,定义酷度为每个节点的度数乘以相应的度对应的权值的总和,求最大酷度。


解题:

    比较直接的想法是dp[i][j],表示前i个节点分配了j点度数能获取的最大值,写法清晰明了,可惜复杂度为n^3,明显超时。

    结合树的特殊结构,每个节点的度数最少为1,因此预先给每个节点分配一点度数,随后再将剩余的2*(n-1)-n点度数分配,使之得到最大的酷度。

    状态转移方程可以改进为dp[i],代表在原来均分了n点度数的基础上,再分配i点度数所能获取的最大酷度。因为已经保障了每个节点至少为1度,后续分配也不会出现多次替换的情况,因此省却了位置这一维,复杂度降为n^2.问题得解。

    dp[i]=max(dp[i],dp[i-j]+f[j+1]-f[1]);


代码:

#include
#include
#include
#include
#include 
using namespace std;
int f[2020],dp[2020];
int main()
{
	int t,n,lim;
	scanf("%d",&t);
	while(t--)
	{
		memset(dp,0,sizeof(dp));
		scanf("%d",&n);
		for(int i=1;i


本站声明: 本文章由作者或相关机构授权发布,目的在于传递更多信息,并不代表本站赞同其观点,本站亦不保证或承诺内容真实性等。需要转载请联系该专栏作者,如若文章内容侵犯您的权益,请及时联系本站删除。
换一批
延伸阅读

本文通过斐波那契数列问题和凑零钱问题来详解动态规划的基本原理。

关键字: 嵌入式 动态规划

360展示广告 平台始终关注广告投放效果,围绕广告后续优化问题先后开发了多款产品。 随着产品规模 的不断扩张,有关效果优化的新需求新问题不断产生。本文介绍了效果优化系统随业务发展 的演进过程,聚焦如何使用算法解决客户痛点...

关键字: 算法 动态规划

动态规划算法与分治法类似,其基本思想就是将待求解问题分解成若干子问题,先求解子问题,然后从这些子问题的解得到原问题的解。与分治法不同的是,适合动态规划法求解的问题,经分解得到的子问题往往不是相互独立的。若用分治法来解这类...

关键字: 算法 动态规划

题目链接:hdu 3062 题面: Party Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Jav

关键字: hdu 入门

题目链接:HDU 4355 题面: Party All the Time Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 65536

关键字: hdu 技巧

题目链接:HDU 4544 题面: 湫湫系列故事——消灭兔子 Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 65535/32768

关键字: hdu 贪心

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3911 题面: Black And White Time Limit: 9000/3000 MS (

关键字: hdu 线段树

题目链接:HDU 5754 题面: Life Winner Bo Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/13

关键字: hdu 博弈

题目链接:HDU 2045 题面: 不容易系列之(3)—— LELE的RPG难题 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 6

关键字: hdu 入门

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5071 题面: Chat Time Limit: 2000/1000 MS (Java/Others

关键字: hdu 区域赛
关闭
关闭